package arm;
import sys.net.*;
import Sys;
import kha.FastFloat;
import haxe.Json;
import sys.io.File;
import cpp.NativeFile;
import iron.object.Object;
import iron.object.CameraObject;
import iron.Scene;
import kha.input.Keyboard;
import iron.system.Time;
import Math;
import kha.input.Mouse;
import iron.system.Input;
class Net extends iron.Trait {
	public function new() {
		super();
		var sensitivity=-.01;
		var mouse:iron.system.Mouse;
		var FPS:Float=60;
		var serverFPS:Float=15;
		var time1:Float;
		var time2:Float;
		var secondTime:Bool=false;
		var playerObject:CameraObject;
		var firstTime:Bool=true;
		var sock:Socket;
		var pertinentScene:Scene=Scene.active;
		var keyMap:Map<String,Array<String>>=new Map<String,Array<String>>();
		var toSend:String;
		var keyboard=iron.system.Input.getKeyboard();
		var defaultMouseMovementX=0.0;
		var defaultMouseMovementY=0.0;
		function makeSenseOfControlFiles() {
			trace(sys.FileSystem.absolutePath("../../"));
			var board=File.getContent(sys.FileSystem.absolutePath("../../")+"/cfg/keyboard.cfg");
			trace("oh.");
			// var pad=File.getContent("cfg/gamepad.cfg");//untested
			//split into relevant parts
			var servercodes:Array<String>=new Array<String>();
			var lines:Array<String>=new Array<String>();
			var iterator:Int=0;
			trace("some vars...");
			for (i in 0...board.length) {
				if (board.charAt(i)=="\n") {
					iterator++;
				} else {
					lines[iterator]+=board.charAt(i);
				}
			}
			trace("lines computed...");
			var half=lines.length/2;
			for (i in 0...cast (half,Int)) {
				lines[i*2]=StringTools.replace(lines[i*2],"null","");
				lines[i*2+1]=StringTools.replace(lines[i*2+1],"null","");
				iterator=0;
				var strInProgress:String="";
				trace("str");
				for (i2 in 0...lines[i*2].length) {
					trace("");
					if (lines[i*2].charAt(i2)==" ") {
						trace("");
						iterator++;
					} else {
						trace("");
						strInProgress+=lines[i*2].charAt(i2);
					}
				}
				var index:Int=Std.parseInt(strInProgress);
				trace(lines.length,i*2+1,lines[i]);
				
				// lines[i*2]=StringTools.ltrim(lines[i*2]);
				// lines[i*2+1]=StringTools.ltrim(lines[i*2+1]);
				// lines[i*2]=lines[i*2].substr(1);
				// lines[i*2+1]=lines[i*2+1].substr(1);
				trace(lines.length,i*2+1,lines[i]);
				var arr:Array<String>=keyMap[strInProgress];
				if (arr==null) {
					arr=new Array<String>();
				}
				trace("err...",arr);
				arr.push(lines[i*2+1]);
				trace("ha!");
				keyMap[strInProgress]=arr;
				trace("");
			}
			trace("soooo...");
		}
		function handleMouse() {
			// var centerx:Int=cast (iron.App.w()/2,Int);
			// var centery:Int=cast (iron.App.h()/2,Int);
			var xm=(mouse.movementX)*sensitivity-defaultMouseMovementX*sensitivity;
			var ym=(mouse.movementY)*sensitivity-defaultMouseMovementY*sensitivity;
			trace(xm,ym,defaultMouseMovementX,defaultMouseMovementY);
			// var forward=playerObject.transform.up();
			// var right=playerObject.transform.right();
			// var up=playerObject.transform.look();
			// trace(forward,right,up);
			// var newforward=forward.mult(Math.cos(xm)).add(up.mult(up.dot(forward)).mult(1-Math.cos(xm)).add(forward.cross(up).mult(Math.sin(xm))));
			// var newright=newforward.cross(up);
			// trace(newforward,newright);
			// var finalforward=newforward.mult(Math.cos(ym)).add(newright.mult(newright.dot(newforward)).mult(1-Math.cos(ym)).add(newforward.cross(newright).mult(Math.sin(ym))));
			// var newup=newright.cross(finalforward);
			// trace(finalforward,newup);
			// trace("activate pitch "+finalforward.x+","+finalforward.y+","+finalforward.z+","+newup.x+","+newup.y+","+newup.z+";");
			// toSend+="activate pitch "+finalforward.x+","+finalforward.y+","+finalforward.z+","+newup.x+","+newup.y+","+newup.z+";";
			playerObject.transform.rotate(playerObject.transform.look(),xm);
			playerObject.transform.rotate(playerObject.transform.right(),ym);
			var newforward = playerObject.transform.up();
			var newup = playerObject.transform.look();
			toSend+="activate pitch "+newforward.x+","+newforward.y+","+newforward.z+","+newup.x+","+newup.y+","+newup.z+";";
			//move pointer
			// mouse.reset();
		}
		function recognizeKeys() {
			for (keyCode in keyMap.keys()) {
				if (keyboard.down(keyCode)) {
					trace(keyCode);
					for (i in 0...keyMap[keyCode].length) {
						if (keyMap[keyCode][i]=="activate slow_traject" || keyMap[keyCode][i]=="activate slow_traject n") {
							toSend += keyMap[keyCode][i]+" 1";
						}
						if (keyMap[keyCode][i]=="activate local_move_z n" || keyMap[keyCode][i]=="activate local_move_z") {
							var dirv=playerObject.transform.up();
							dirv=dirv.normalize();
							if (Math.abs(dirv.x)>1) {
								dirv.x=1;
							}
							trace("Z!",dirv.x,dirv.y,dirv.z);
							toSend+=keyMap[keyCode][i]+" "+(dirv.x)+","+(dirv.y)+","+(dirv.z)+";";
						}
						if (keyMap[keyCode][i]=="activate local_move_x n" || keyMap[keyCode][i]=="activate local_move_x") {
							var dirv=playerObject.transform.right();
							dirv=dirv.normalize();
							trace("Z!",dirv.x,dirv.y,dirv.z);
							toSend+=keyMap[keyCode][i]+" "+(dirv.x)+","+(dirv.y)+","+(dirv.z)+";";
						}
						if (keyMap[keyCode][i]=="activate local_move_y n" || keyMap[keyCode][i]=="activate local_move_y") {
							var dirv=playerObject.transform.look();
							dirv=dirv.normalize();
							trace("Z!",dirv.x,dirv.y,dirv.z);
							toSend+=keyMap[keyCode][i]+" "+(dirv.x)+","+(dirv.y)+","+(dirv.z)+";";
						}
					}
				}
			}
		}
		function updateObject(root:Object,desired:Dynamic):Bool {
			for (o in root.children) {
				if (o.name==desired.Name) {
					//update
					o.transform.loc.x=desired.Loc.X;
					o.transform.loc.y=desired.Loc.Y;
					o.transform.loc.z=desired.Loc.Z;
					// o.transform.rot=o.transform.rot.fromEuler(Math.acos(desired.Loc.X),Math.acos(desired.Loc.Y),Math.acos(desired.Loc.Z));
					trace("unto the breach!");
					o.properties=new Map<String,Int>();
					o.properties.set("TrajectX",desired.Trajectory.X);
					o.properties.set("TrajectY",desired.Trajectory.Y);
					o.properties.set("TrajectZ",desired.Trajectory.Z);
					// o.transform.loc.x=Math.acos(desired.Rot.X);
					return true;
				}
				updateObject(o,desired);
			}
			return false;
		}
		function properRead():String {
			var result:StringBuf=new StringBuf();
			while (true){
				var byte=sock.input.readByte();
				// trace(byte);
				if (byte==64){
					return result.toString();
				}
				result.addChar(byte);
			}
			return result.toString();
		}
		notifyOnInit(function() {
			mouse=iron.system.Input.getMouse();
			// mouse.lock();
			mouse.hide();
			
			Sys.sleep(0.5);
			defaultMouseMovementX=mouse.movementX;
			defaultMouseMovementY=mouse.movementY;
			playerObject=iron.Scene.active.camera;
			sock=new Socket();
			trace("interesting-ish");
			sock.connect(new Host("192.168.2.165"),1251);
			// sock.setBlocking(false);
			trace("interest-ish");
			sock.write("12345 CPPHaxeLord@");
			trace("err!");
			trace("aaaagh");
			var ack=properRead();
			if (ack!="initack") {
				trace("BADACK "+ack);
				Sys.exit(-1);
			}
			//keyboard and gamepad init
			makeSenseOfControlFiles();
			// keyboard.notify(recognizeKey,null,null);
		});
		function clientsidepredict(root:Object) {
			for (ob in root.children) {
				trace(ob.name);
				if (null!=ob.properties&&ob.properties.exists("TrajectX")) {
					trace("Aha");
					var divBy=FPS/serverFPS;
					ob.transform.loc.x+=ob.properties.get("TrajectX")/divBy;
					trace(divBy);
					ob.transform.loc.y+=ob.properties.get("TrajectY")/divBy;
					ob.transform.loc.z+=ob.properties.get("TrajectZ")/divBy;
				}
				clientsidepredict(ob);
			}
		}
		function onUpdateSpawn(ob:Object) {
			trace("I'll add a mesh later");
		}
		notifyOnUpdate(function() {
			//clientsideprediction
			Time.update();
			var fTime=Time.realTime();
			recognizeKeys();
			handleMouse();
			trace("FPS!",FPS);
			clientsidepredict(pertinentScene.root.children[0]);
			// trace(playerObject.transform.loc.x,playerObject.transform.loc.y,playerObject.transform.loc.z);
			// trace("tick");
			//send input
			// trace(toSend+"@");
			// toSend=StringTools.replace(toSend,"[","");
			// toSend=StringTools.replace(toSend,"]","");
			toSend=StringTools.replace(toSend,"null","");
			trace(toSend+"@");
			sock.write(toSend+"@");
			toSend="";
			var j=properRead();
			var oblist:Array<Dynamic>=Json.parse(j);
			//update everything
			for (ob in 0...oblist.length) {
				// trace(oblist[ob].Name);
				var updated=updateObject(pertinentScene.root,oblist[ob]);
				if (!updated) {
					pertinentScene.spawnObject("placeholder",pertinentScene.root,onUpdateSpawn,true);
					updateObject(pertinentScene.root,oblist[ob]);
				}
			}
			Time.update();
			var sTime=Time.realTime();
			Sys.sleep((sTime-fTime)/1000000);
		});
		
		// notifyOnRemove(function() {
		// });
		
	}
}
